//
//  Project   : libnet
//  File      : basisFE.cc
//  Author    : Sabine Gutsch / Thomas Probst
//  Purpose   : basis class for finite elements
//
// arch-tag: 781611fe-3d33-4a1f-911d-a9d6439018ce
//

#include "TBasisFE.hh"

// upwinding functions
TFloat 
simple ( TFloat x ) { return  ( x >= 0 ? 1 : 0 ); }
    
TFloat 
Samarskij ( TFloat x ) {
	if ( x >= 0 ) return ( (1+2*x) / (2+2*x) );
	else  return ( 1 / (2-2*x) );
}

//
// set and get verbosity 
//
template <int N>
void 
TBasisFE<N>::setVerbosity (const uint averb  ) 
{ verbosity = averb; }

template <int N>
uint 
TBasisFE<N>::getVerbosity () const 
{ return verbosity; }
