//
//  Project     : libgraph
//  File        : fvs.cc
//  Author      : Ronald Kriemann
//  Purpose     : class building FVS for different types of graphs
//  Date        : 30.07.1997
//
// arch-tag: ca6a55dc-a2d9-48d1-a83d-c94102911718
//

#include "basegraph.hh"

#include "blockinfo.hh"
#include "planarFVS.hh"
#include "heuristicFVS.hh"

#include "fvs.hh"

//
// constructor
//
TFVS::TFVS ()
{}

//
// builds the FVS
//
TList<TNode>*
TFVS::buildFVS ( TGraph& graph, uint fvsType )
{
	if (fvsType == PLANAR_FVS)
	{
		TPlanarFVS  fvs;
		return fvs.buildFVS( graph );
	}// if
	else
	{
		THeuristicFVS  fvs;
		return fvs.buildFVS( graph );
	}// else
}
