//
//  Project   : libnet
//  File      : T3DCubeDomain.hh
//  Author    : Ronald Kriemann
//  Purpose   : class for representing a cubic domain in R^3
//
// arch-tag: 68f90289-94be-4f52-8766-238e01c0c437
//

#ifndef __T3DCUBEDOMAIN_HH
#define __T3DCUBEDOMAIN_HH

#include "TDomain.hh"

//
//
//
class T3DCubeDomain : public TDomain
{
public:
    ////////////////////////////////////////////////////////////
    //
    // constructor and destructor
    //

    T3DCubeDomain ();

    virtual ~T3DCubeDomain ();

    ///////////////////////////////////////////////////////////
    //
    // misc methods
    //

    // characteristic function of domain
    virtual bool charFunc ( TVector<3> * pVector ) const;
};

#endif  // __T3DCUBEDOMAIN_HH
