//
//  Project   : libnet
//  File      : basisDoFManager.hh
//  Author    : Sabine Gutsch
//  Purpose   : basis class for DoF manager
//
// arch-tag: e76fb5fa-920d-4c6a-af50-668447a1856e
//

#ifndef __TBASISDOFMANAGER_HH
#define __TBASISDOFMANAGER_HH

#include "memory.hh"

#include "net.hh"
#include "blockmatrix.hh"

//
// basis class for DoF manager
//
template <int N>
class TBasisDoFManager : public TMemory {

public:
	// constructors	
    TBasisDoFManager () {}
	// destructor
    virtual ~TBasisDoFManager () {}
 
   // initialise Dofs
   virtual void initDoFDesc( TNet<N> *cNet, TNet<N> *fNet = NULL) = 0;
  
   virtual TBlockMatrix* buildStiffnessMatrix( TNet<N> *cNet, 
											   TNet<N> *fNet = NULL ) = 0;
};

#endif  // __TBASISDOFMANAGER_HH
