//
//  Project   : libnet
//  File      : TBasisEqn.hh
//  Author    : Sabine Gutsch / Thomas Probst
//  Purpose   : basis class for pdes
//
// arch-tag: 61f8d600-879a-4696-a600-15228dd6f9ae
//

#ifndef __TBASISEQN_HH
#define __TBASISEQN_HH

#include "memory.hh"
#include "parray.hh"
#include "vertex.hh"

#include "vector.hh"
#include "blockvector.hh"

#include "convDirections.hh"
#include "TFunction.hh"


//
// basis class for a pde
//
template <int N>
class TBasisEqn : public TMemory {

public:
  // constructors	
   TBasisEqn(){}; 
   
   // destructor
   virtual ~TBasisEqn () { };
   
   // evaluate rhs
   virtual TFloat evalRhs(TVector<N> *v, uint i = 0) const = 0;

};

// some types

#endif  // __TBASISEQN_HH


