//
//  Project   : libnet
//  File      : TBoundary.hh
//  Author    : Ronald Kriemann
//  Purpose   : class for representing a boundary in R^n
//
// arch-tag: 18cca48f-0da4-4918-a3c9-c190d3fd640c
//

#ifndef __TBOUNDARY_HH
#define __TBOUNDARY_HH

#include "memory.hh"
#include "TString.hh"

#include "TBoundaryDesc.hh"

//
// this class holds info about condition on the boundary
// aka dirichlet, neumann in an abstract manner
//
class TBoundary : public TMemory
{
protected:
    // description for this boundary
    TBoundaryDesc  * pBoundDesc;
    TString          _name;
  
public:
    // constructor
    TBoundary ();
    TBoundary ( const TString & name );

    // destructor
    ~TBoundary ();

    // access desc
    TBoundaryDesc * getBoundaryDesc () const;
    void setBoundaryDesc ( TBoundaryDesc * desc );

    // access name
    const TString & getName () const;
    void setName ( const TString & name );
};

#endif  // __TBOUNDARY_HH
