//
//  Project   : libnet
//  File      : TBoundaryDesc.hh
//  Author    : Ronald Kriemann
//  Purpose   : class for representing info about boundaryvalues
//
// arch-tag: a18c832e-599b-4ab4-a357-ea3ed7bdb923
//

#ifndef __TCDRBOUNDARYDESC_HH
#define __TCDRBOUNDARYDESC_HH

#include "memory.hh"
#include "dynarray.hh"
#include "multiref.hh"
#include "TFunction.hh"
#include "TBoundaryDesc.hh"

// default type
#define NO_TYPE  -1

//
//
//
template <int N>
class TCdrBoundaryDesc : public TBoundaryDesc
{
protected:
    // functions on boundary: Neumann or Dirichlet
    TDynArray<TFunction< N > * > arrFunc;
    // template size N  (= dimension of Function)
    int aN;

public:
    // constructor
    TCdrBoundaryDesc ( int n = 0 );

    // destructor
    ~TCdrBoundaryDesc ();
    
    // getN
    virtual int getN() const { return aN;}
   

   // initialisation
    void setNoOfTypes ( uint n );

    // access functions
    TFunction< N >*  getFunc ( uint i ) const;
    void setFunc ( uint i, TFunction< N >*  af);
};

#endif  // __TCDRBOUNDARYDESC_HH
