//
//  Project     : libgraph
//  File        : TFSNode.hh
//  Author      : Ronald Kriemann
//  Purpose     : class representing a flowsurface in a graph
//
// arch-tag: 226c1dc5-fc9a-4a92-bf57-0295eb6bb307
//

#ifndef __TFSNODE_HH
#define __TFSNODE_HH

#include "nodes.hh"

//
//
//
class TFSNode : public TMarkableNode
{
protected:
    // the flowsurface we represent
    T3DCellEdgeGraph * pFlowSurface;

public:
    /////////////////////////////////////////////
    //
    // constructor and destructor
    //

    TFSNode ( uint name, T3DCellEdgeGraph * pFS );

    ~TFSNode ();

    /////////////////////////////////////////////
    //
    // access member variables
    //

    T3DCellEdgeGraph * flowSurface () const;
};

#endif  // __TFSNODE_HH
