#ifndef __TFUNCTION_HH
#define __TFUNCTION_HH
//
//  Project   : libnet
//  File      : TFunction
//  Author    : Sabine Gutsch / Thomas Probst
//  Purpose   : basis class functions
//  Date      : 8.06.1998
//  Changes   : 
//
#include "memory.hh"
#include "vector.hh"
// arch-tag: aa409b5a-ae4a-4e6c-a7da-fef513b177c3
//


template <int N>
class TFunction : public TMemory {
   
protected:
    char *name;

public:
    // destructor
    virtual ~TFunction () {}
    
    // get Number of Arguments
    virtual TFloat eval(TVector <N> *v ) =0;

    // get (set) name
    void setName ( const char *n );
    char* getName ();
};
//
// get (set) name
//
template <int N>
char* 
TFunction<N>::getName ()
{
	return name;
}

template <int N>
void 
TFunction<N>::setName ( const char *n )  
{ 
	name = new char[strlen(n)+1]; 
	strcpy(name, n);
}

#endif // __TFUNCTION_HH
