//
//  Project   : libmisc
//  File      : TOctave.hh
//  Author    : Ronald Kriemann
//  Purpose   : class for a octave interface
//
// arch-tag: e03e6974-104c-4da8-a4fb-45a86225af4c
//

#ifndef __TOCTAVE_HH
#define __TOCTAVE_HH

#include "matrixblock.hh"
#include "blockvector.hh"

//
// this class defines a simple interface to octave
// via static member methods
// - for input/output of matrices and vectors
//
class TOctave
{
public:
    /////////////////////////////////////
    //
    // IO of matrices
    //

    static void saveMatrix ( TMatrixBlock * pMatrix,
                             const char * filename, 
                             const char * matname );

    /////////////////////////////////////
    //
    // IO of vectors
    //

    static void saveVector ( TVectorBlock<TFloat> * pVector,
                             const char * filename, 
                             const char * vecname );

protected:
    /////////////////////////////////////
    //
    // misc help routines
    //

    // check if index is an index in entries
    static long isIndex ( uint index, uint * entries, uint noOfEntries );
};

#endif  // __TOCTAVE_HH
