//
//  Project   : libnet
//  File      : TPDEBoundaryDesc.hh
//  Author    : sg/tpr
//  Purpose   : class for representing info about boundaryvalues
//
// arch-tag: 8bdc0506-ce0a-4129-99d3-e436e29739f7
//

#ifndef __TPDEBOUNDARYDESC_HH
#define __TPDEBOUNDARYDESC_HH

#include "memory.hh"
#include "dynarray.hh"
#include "multiref.hh"
#include "TFunction.hh"
#include "TBoundaryDesc.hh"

// default type
#define NO_TYPE  -1

//
//
//
template <int N>
class TPDEBoundaryDesc : public TBoundaryDesc
{
protected:
    // functions on boundary: Neumann or Dirichlet
    TDynArray<TFunction< N > * > arrFunc;
    // template size N  (= dimension of Function)
    int aN;

public:
    // constructor
    TPDEBoundaryDesc ( int n = 0 );

    // destructor
    ~TPDEBoundaryDesc ();
    
    // getN
    virtual int getN() const;
   
    // initialisation
    void setNoOfTypes ( uint n );

    // access functions
    TFunction< N >* getFunc ( uint i ) const;
    void setFunc ( uint i, TFunction< N >*  af);
};

#endif  // __TPDEBOUNDARYDESC_HH
