//
//  Project     : libmatrix
//  File        : TPermutation.hh
//  Author      : Ronald Kriemann
//  Purpose     : class for a permutation vector
//
// arch-tag: 527b8724-1f01-4e59-88c8-450b11ac96af
//

#ifndef __TPERMUTATION_HH
#define __TPERMUTATION_HH

#include "defines.hh"
#include "dynarray.hh"

//
// this class implements a permutation vector
//
class TPermutation : public TDynArray< uint >
{
public:
    ///////////////////////////////////////////
    //
    // constructor and destructor
    //

    TPermutation ( uint size = 0 );
    TPermutation ( const TPermutation & perm );

    ~TPermutation ();

    ///////////////////////////////////////////
    //
    // misc. methods for perm. handling
    //

    // invert permutation
    TPermutation invert ();

    // reverse permutation order
    TPermutation reverse ();

    ///////////////////////////////////////////
    //
    // various operators
    //

    // set all entries in perm to n
    TPermutation & operator = ( const uint n );

    // output
    friend ostream & operator << ( ostream & os, const TPermutation & perm );
};

#endif  // __TPERMUTATION_HH
