//
//  Project     : libgraph
//  File        : TRedBlack.hh
//  Author      : Thomas Probst
//  Purpose     : class to build red-black permutation
//
// arch-tag: cacb59d8-944e-4741-8973-339df23ba99c
//

#ifndef __TREDBLACK_HH
#define __TREDBLACK_HH

#include "defines.hh"

#include "matrixblock.hh"
#include "TPermutation.hh"

#include "basegraph.hh"
#include "nodes.hh"
#include "graphtool.hh"
//
//
//
class TRedBlack
{
public:
    /////////////////////////////////////////
    //
    // constructor and destructor
    //

    TRedBlack ();

    ~TRedBlack ();

    /////////////////////////////////////////
    //
    // methods for permutation building
    //

    // determine Red-Black-Ordering
    TPermutation * orderBFS ( TGraph & graph, uint & noOfReds );
    
    // determine Black-Red-Ordering (same as RedBlack, but Black Nodes are isolated)
    TPermutation * orderBFS_isolated ( TGraph & graph, uint & NoOfReds );

    // doing BFS
    void bfs ( TGraph & graph );

    // visit node in BFS
    void visit ( TMarkableNode * pNode );
};

#endif  // __REDBLACK_HH
