//
//  Project   : libnet
//  File      : basisDoFManager.hh
//  Author    : Sabine Gutsch
//  Purpose   : basis class for DoF manager
//
// arch-tag: 8fb79141-b583-4516-9fe4-06f672a382ba
//

#ifndef __BASISDOFMANAGER_HH
#define __BASISDOFMANAGER_HH

#include "memory.hh"

#include "net.hh"
#include "blockmatrix.hh"

//
// basis class for DoF manager
//
template <int N>
class TBasisDoFManager : public TMemory {

public:
    // constructors    
    TBasisDoFManager () {}
    // destructor
    virtual ~TBasisDoFManager () {}

    virtual TBlockMatrix* buildStiffnessMatrix( TNet<N> *cNet, 
                                                TNet<N> *fNet = NULL )=0;
};

#endif  // __BASISDOFMANAGER_HH
