//
//  Project   : libnet
//  File      : bicgStab.hh
//  Author    : Sabine Gutsch / Thomas Probst
//  Purpose   : bicg-STAB solver
//
// arch-tag: e90f953c-c61e-46f7-aa72-7add085363a7
//

#ifndef __BICGSTAB_HH
#define __BICGSTAB_HH

#include "TPrecSolver.hh"

//
// notation follows p.28 of diploma thesis
//
class TBicgStab : public TPrecSolver
{
public:
    // constructor
    TBicgStab( TSolver  * prec     = NULL,
               uint       amaxiter = DEFAULT_MAX_ITERATION, 
               TFloat     aaccur   = DEFAULT_ACCURACY, 
               uint       averb    = 0 );

    //
    // iteration
    //
    
    void init ();
    int  step ();
    void solve ();
    void solve ( int                     level,
                 TBlockMatrix         ** A,
                 TBlockVector<TFloat> ** RHS,
                 TBlockVector<TFloat> ** x );
};

#endif  // __BICGSTAB_HH
