//
//  Project   : libnet
//  File      : confDiffHierarchy.hh
//  Author    : Sabine Gutsch / Thomas Probst
//  Purpose   : class to build a matrix and prolongation hierarchy for
//              the convection-diffusion equation
//
// arch-tag: f67ae10d-0a45-4eb2-b60e-8b78f4008d4a
//

#ifndef __CONVDIFFHIERARCHY_HH
#define __CONVDIFFHIERARCHY_HH

//
// class to build a matrix and prolongation hierarchy for
// the convection-diffusion equation
//

#include "basisHierarchy.hh"
#include "convDiffFE.hh"
#include "convDiffDoFManager.hh"

class T2DConvDiffHierarchy : public T2DBasisHierarchy
{
public:
	// constructor
	T2DConvDiffHierarchy () {};

    void buildHierarchy ( TBasisDoFManager<2> *dofManager,
                          T2DBasisEqn *eqn,
                          T2DBasisFE *fe,
                          TNetHierarchy<2> *netHier, 
                          TBlockMatrix **pMatrix, 
                          TBlockVector<TFloat> **pRHS, 
                          TBlockVector<TFloat> **pX );
};

#endif  // __CONVDIFFHIERARCHY
