#ifndef __FIFO_HH
#define __FIFO_HH
//
//  Project  : libmisc
//  File     : fifo.hh
//  Author   : Kai Helms / Ronald Kriemann
//  Purpose  : a fifo class
//  Date     : 24.04.1997
//
// arch-tag: 562c2a75-ddf6-4377-9ac5-1496341c121e
//

#include "list.hh"

//
// the fifoclass
//
template<class T>
class TFifo : public TList<T> 
{
public:
	// constructor
	TFifo () { nSize = 0; pFirst = pLast = NULL; }

	// are entries in the list
	bool isFilled () { return (nSize); }
	// are no entries in the list
	bool isEmpty () { return (!nSize); }

	// append object to the list
	TFifo<T>& operator<< ( T& object ) 
	{
		add( object );
		return (*this);
	}

	// return first object and remove it
	TFifo<T>& operator>> ( T* object ) 
	{
		if (nSize == 0) 
			cerr << "TFifo::operator>> (T*) : no elements in list" << endl;

		if (pFirst != NULL)
		{
			Item  *pItem = pFirst->pNext;
			object = pFirst->pElement;
			delete (pFirst);
			pFirst = pItem;
			nSize--;
		}// if

		return (*this);
	}
};

#endif  // __FIFO_HH
