//
//  Project     : libgraph
//  File        : fvs.hh
//  Author      : Ronald Kriemann
//  Purpose     : class building FVS for different types of graphs
//  Date        : 30.07.1997
//
// arch-tag: 734db54e-4184-4766-a56b-191ce18a3e9b
//

#ifndef __FVS_HH
#define __FVS_HH

#include "memory.hh"

#include "basenode.hh"

// forward decl.
class TGraph;

// mark of fvs nodes
#define FVS_NODE  255

//
// This class builds a Feedback Vertex Set of a given graph.
//
class TFVS : public TMemory
{
public:
	// constructor
	TFVS ();

	// builds the FVS
	TList<TNode>* buildFVS ( TGraph& graph, uint fvsType );
};

#endif  // __FVS_HH
