//
//  Project   : libnet
//  File      : kaczmarz.hh
//  Author    : Sabine Gutsch
//  Purpose   : kaczmarz solver
//
// arch-tag: 35016fa5-c7fa-4db9-b10b-98a85bb00de6
//

#ifndef __KACZMARZ_HH
#define __KACZMARZ_HH

#include "solver.hh"

class TKaczmarz : public TSolver {

protected:
	// transposed row of matrix
    TSparseBlockVector a;

public:
	// constructor
	TKaczmarz( TBlockMatrix *paA = NULL, 
               TBlockVector<TFloat> *paRHS = NULL, 
			   TBlockVector<TFloat> *paX = NULL, 
               uint amaxiter = DEFAULT_MAX_ITERATION,
               TFloat aaccur = DEFAULT_ACCURACY,
               uint averb = 0 );

	// one iteration step
    int step ();
};

#endif  // __KACZMARZ_HH
			
