//
//  Project   : libmisc
//  File      : memory.hh
//  Author    : Ronald Kriemann
//  Purpose   : basic class for object counting
//
// arch-tag: 3801bbf5-1b09-4800-8b41-7715fda74864
//

#ifndef __MEMORY_HH
#define __MEMORY_HH

#include "defines.hh"

//
// this class counts all creations of subclasses
//
class TMemory 
{
protected:
    // counters for the memstat
    static uint nNoOfAlloc;
    static uint nNoOfDealloc;

public:
    TMemory() { nNoOfAlloc++; }
    ~TMemory() { nNoOfDealloc++; }

    // print statistics
    static void statistics ();
    static void statActive ();

    // return used memory (in kbytes)
    static uint used ();
};

#endif  // __MEMORY_HH
