//
//  Project   : libmisc
//  File      : parser.hh
//  Author    : Ronald Kriemann
//  Purpose   : class for parsing a file for the init. tri.
//
// arch-tag: 84279e9b-b45b-45dd-87c2-e8f977911d10
//

#ifndef __PARSER_HH
#define __PARSER_HH

#include "memory.hh"
#include "list.hh"

#include "cell.hh"

//
// the parser goes through the given file and
// creates a cell list with the given information
//
class TParser : public TMemory 
{
protected:
    // filename for reading
    char                szFilename[256];

    // pointer to built cell-lists
    TList< TCell<2> >  *pList2DCells;
    TList< TCell<3> >  *pList3DCells;

public:
    // constructor
    TParser ( const char *filename );

    // build the celllist with the init. tri.
    TParser & buildList ();

    // access cell-lists
    TList< TCell<2> > * get2DCellList () const;
    TList< TCell<3> > * get3DCellList () const;
    void * getCellList ( int n ) const;

    // return dim of red file (0 for no list built)
    int getDim () const;
};

#endif  // __PARSER_HH
