#ifndef _sortable_data_collection_hh
#define _sortable_data_collection_hh
// arch-tag: c56c6bfa-a6f7-4a91-9202-49b0ac1e90d0
//


class SortableDataCollection {

private:

  virtual int get_number_of_items() const = 0;
  virtual int smaller_item(int, int) const = 0;
  virtual void exchange(int, int) = 0;

  int standard_compare( const int *  , const int *  );
  void bottom_up_pass(int);
  void top_down_pass(int, int);

  SortableDataCollection(const SortableDataCollection&);

  SortableDataCollection& operator=(const SortableDataCollection&);

public:

  SortableDataCollection();
  virtual ~SortableDataCollection();

  void heapsort();
  void quicksort();
  void bubblesort();
  void mergesort();

};

#endif


