#ifndef __STACK_HH
#define __STACK_HH
//
//  Project   : libmisc
//  File      : stack.hh
//  Author    : Ronald Kriemann
//  Purpose   : Template class for a stack
//
// arch-tag: 1a81d942-864f-4576-b4ad-dc4ef2e7f258
//

#include "list.hh"

//
// class for a stack (LIFO)
// so last pushed object is first in list
//
template <class T>
class TStack : public TList<T>
{
public:
    /////////////////////////////////////////////
    //
    // constructors and destructors
    //

    TStack ();

    /////////////////////////////////////////////
    //
    // typical stack methods :)
    //

    void push ( T * object );
    T *  pop ();
    
    T *  head ();

    const bool empty () const;
};

/////////////////////////////////////////////
//
// constructors and destructors
//

template <class T>
TStack<T>::TStack ()
        : TList<T> ()
{}

/////////////////////////////////////////////
//
// typical stack methods :)
//

template <class T>
void
TStack<T>::push ( T * object )
{
    insert( * object );
}

template <class T>
T *
TStack<T>::pop ()
{
    T * pTmp;

    pTmp = TList<T>::getFirst();

    remove( * TList<T>::pFirst );

    return pTmp;
}

template <class T>
T *
TStack<T>::head ()
{
    return TList<T>::getFirst();
}

template <class T>
const bool
TStack<T>::empty () const
{
    return (TList<T>::getSize() == 0);
}

#endif  // __STACK_HH
