//
//  Project :  libvisual
//  File    :  styles.hh
//  Purpose :  classes for all kind of styles
//  Author  :  Ronald Kriemann
//
// arch-tag: 8609ab95-63af-4c65-a3ad-beadac241a3a
//

#ifndef __STYLES_HH
#define __STYLES_HH

#include "defines.hh"

// some colors
#define COLOR_BLACK      0x000000
#define COLOR_DARKGRAY   0x404040
#define COLOR_GRAY       0x808080
#define COLOR_LTGRAY     0xC0C0C0
#define COLOR_WHITE      0xFFFFFF

#define COLOR_RED        0xFF0000
#define COLOR_GREEN      0x00FF00
#define COLOR_BLUE       0x0000FF
#define COLOR_YELLOW     0xFFFF00

#define COLOR_DARKRED    0x800000
#define COLOR_DARKGREEN  0x008000
#define COLOR_DARKBLUE   0x000080
#define COLOR_DARKYELLOW 0x808000


// type for colors
class TColorType
{
public:
    TFloat   r, g, b;
    TFloat   filter, transmit;
    TFloat   amb_r, amb_g, amb_b;

    TColorType & operator = ( const TColorType & color );
};

// predifined fontnames, styles and justifications
#define  FONT_SERIF       0
#define  FONT_SANS        1
#define  FONT_TYPEWRITER  2

#define  STYLE_NONE    0x0
#define  STYLE_BOLD    0x1
#define  STYLE_ITALIC  0x2

#define  JUST_LEFT    0
#define  JUST_RIGHT   1
#define  JUST_CENTER  2

// type for fonts
class TFontType
{
public:
    uint    font;
    TFloat  size;
    uint    style;
    TFloat  width;
    TFloat  spacing;
    uint    justification;

    TFontType & operator = ( const TFontType & f );
};

#endif  // __STYLES_HH
