//
//  Project   : libmisc
//  File      : timer.hh
//  Author    : Ronald Kriemann
//  Purpose   : class for a timer (for speed tests)
//
// arch-tag: 8d048926-721c-4be6-aba2-f1a15f7b9117
//

#ifndef __TIMER_HH
#define __TIMER_HH

extern "C" {
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
}

#include "defines.hh"

//
// the timer class
//
class TTimer 
{
protected:
	// the two timers
	struct rusage timerStart, timerEnd;

public:
	// constructor
	TTimer ();

	// sets the first timer
	void start ();

	// sets the second timer
	void stop ();
	
	// returns time between start and end as float
	const TFloat stat ();

	// converts timeval to in sec and m_sec
	void convertTime( struct timeval start, struct timeval end,
					  long &sec, long &m_sec ) const;

	// stream output (only the time)
	friend ostream& operator<< ( ostream& os, const TTimer& timer );
};

#endif  // __TIMER_HH
