//
//  Project :  libvisual
//  File    :  view.hh
//  Purpose :  baseclass for all drawings
//  Author  :  Ronald Kriemann
//
// arch-tag: 3ce924e7-dc4c-4673-9cde-881269012a3f
//

#ifndef __VIEW_HH
#define __VIEW_HH

#include "memory.hh"

#include "printer.hh"
#include "T3DPrinter.hh"

//
// this class is an abstract baseclass for all drawingclasses
// and has only the definition for the draw-method
//
class TView : public TMemory
{
public:
	// constructor
	TView ();

	virtual ~TView ();

	// draw on screen
	virtual void draw ( TPrinter & );
	virtual void draw3D ( T3DPrinter & );
};

#endif  // __VIEW_HH
