//
//  Project   : libnet
//  File      : TBoundary.cc
//  Author    : Ronald Kriemann
//  Purpose   : class for representing a boundary in R^n
//
// arch-tag: 61d90333-0c4a-4061-ad20-c0d05d461a28
//

#include "TBoundary.hh"

//
// constructor
//
TBoundary::TBoundary ()
{
    pBoundDesc = NULL;
}

TBoundary::TBoundary ( const TString & name )
{
    pBoundDesc = NULL;
    _name      = name;    
}

//
// destructor
//
TBoundary::~TBoundary ()
{
    if ((pBoundDesc != NULL) && (pBoundDesc->delRef()))
        delete pBoundDesc;
}

//
// access desc
//
TBoundaryDesc *
TBoundary::getBoundaryDesc () const
{
    return pBoundDesc;
}

void
TBoundary::setBoundaryDesc ( TBoundaryDesc * desc )
{
    if (pBoundDesc != NULL)
        cout << "TBoundary::setBoundaryDesc (...) : already have a desc" << endl;

    pBoundDesc = desc;

    if (pBoundDesc != NULL)
        pBoundDesc->addRef();
}

//
// access name
//
const TString &
TBoundary::getName () const
{
    return _name;
}

void
TBoundary::setName ( const TString & name )
{
    _name = name;
}
