//
//  Project    : libnet
//  File       : TDoFDesc.cc
//  Author     : Ronald Kriemann 
//  Purpose    : class for holding dof names
//
// arch-tag: 0b184c9f-bfb9-4d86-87e2-e98caecb1895
//

#include "defines.hh"

#include "TDoFDesc.hh"

//
// constructor
//
TDoFDesc::TDoFDesc ( int m )
{
    int  i;
    
    noOfNames = m;
        
    if (noOfNames > 0)
    {
        arrNames = new long[noOfNames];
        for (i = 0; i < noOfNames; i++)
            arrNames[i] = NOT_DEFINED;
    }// if
    else
    {
        arrNames  = NULL;
        noOfNames = 0;
    }// else
}

//
// destructor
//
TDoFDesc::~TDoFDesc ()
{
    if (arrNames != NULL)
        delete arrNames;
}

//
// access names
//
long
TDoFDesc::getName ( int i ) const
{
    if (i < noOfNames)
        return arrNames[i];
    else
    {
        cerr << "TDoFDesc::getName (" << i << ") : range exception (max = "
             << noOfNames << ")" << endl;
        return NOT_DEFINED;
    }// else
}
    
void
TDoFDesc::setName ( int i, int name )
{
    if (i < noOfNames)
        arrNames[i] = name;
    else
        cerr << "TDoFDesc::setName (" << i << ",int) : range exception (max = "
             << noOfNames << ")" << endl;
}
