//
//  Project   : libnet
//  File      : TStokesBoundaryDesc.cc
//  Author    : Ronald Kriemann
//  Purpose   : class for representing info about boundaryvalues
//
// arch-tag: 67ec221a-c82f-47cb-884e-be4488dbb5ac
//

#include "TStokesBoundaryDesc.hh"

//
// constructor
//
template< int N> 
TStokesBoundaryDesc<N>::TStokesBoundaryDesc ( int n ) 
{
 setNoOfTypes( n );
}

//
// destructor
//
template< int N> 
TStokesBoundaryDesc<N>::~TStokesBoundaryDesc ()
{
}


// initialisation
template< int N> 
void
TStokesBoundaryDesc<N>::setNoOfTypes ( uint n )
{
    uint  oldSize = arrType.getSize();
    uint  i;
    
    arrType.setSize( n );
    arrFunc.setSize( n );

    clearFlags();
    
    for (i = oldSize; i < n; i++)
    {
       arrType[i]  = NO_TYPE;
       arrFunc[i] = NULL;
    }// for
}
   
//
// access func info
//
template< int N > 
TFunction<N> * TStokesBoundaryDesc<N>::getFunc ( uint i ) const
{
    if (i < getNoOfTypes())
        return arrFunc[i];
    else
    {
        cout << "TStokesBoundaryDesc::getFunc (" << i << ") : index too high" << endl;
        return NULL;
    }// else
}
template< int N> 
void
TStokesBoundaryDesc< N >::setFunc ( uint i, TFunction < N >* af )
{
    if (i < getNoOfTypes())
        arrFunc[i] = af;
    else
        cout << "TStokesBoundaryDesc::setFunc (" << i << ",int) : index too high" << endl;
}

template class TStokesBoundaryDesc<2>;
template class TStokesBoundaryDesc<3>;
