//
//  Project   : libnet
//  File      : cell.hh
//  Author    : Ronald Kriemann / Sabine Gutsch
//  Purpose   : class for a cell (smallest part of a net (see net.hh))
//
// arch-tag: 073b6877-7e73-4f51-ac94-86c10431bdbb
//

#include <math.h>

#include "cell.hh"

//
// return vertex opposite of i'th frontier
//
TVertex<2>* 
TCell<2>::getOppositeNode ( uint i ) const
{
    return getFrontier((i+1)%3)->getNode(this, 2);
}

TVertex<3>* 
TCell<3>::getOppositeNode ( uint i ) const
{
    return NULL;
}

//
// calculate size of cell (2D: area, 3D: volume)
//
TFloat 
TCell<2>::calcSize ()
{
    TVector<2> v, w;

    v = (*getNode(1)) - (*getNode(0));
    w = (*getNode(2)) - (*getNode(0));

    return (fabs(0.5 * (v[X] * w[Y] - v[Y] * w[X])));
}
TFloat 
TCell<3>::calcSize ()
{
  
   cerr<<" TCell<3>::calcSize: not implemented"<<endl;
    return 0.0;
}
