//
//  Project  : libnet
//  File     : lu.cc
//  Author   : Sabine Gutsch
//  Purpose  : lu solver
//
// arch-tag: f9a92ea2-6084-4dc2-b41d-6794eff2fdfc
//

#include "lu.hh"

//
// constructor
//
TLU::TLU( TBlockMatrix *paA, 
          TBlockVector<TFloat> *paRHS, 
          TBlockVector<TFloat> *paX, 
          uint amaxiter,
          TFloat aaccur,
          uint averb ) 
        : TSolver ( paA, paRHS, paX, amaxiter, aaccur, averb) 
{
	setName("LU"); 
}

//
// one iteration step
//
int 
TLU::step () 
{ 
    if ( pA->hasLUdecomp() == FALSE) 
        //pA->calculateLUdecomp();
        pA->calcStokesLUdecomp1();
	    //pA->calcStokesLUdecomp2();
	    //cout << "lu decomp calculated\n";}
	
    //else cout << "lu was already there\n";
    (*pX) = pA->solveLUdecomp( *pRHS );
	
	return (RETURN_CONTINUE);
}
